-- 超凡入圣
Lua_CQiYuanPanel = class("Lua_CQiYuanPanel",Lua_DisplayObject)
function Lua_CQiYuanPanel:ctor(p)	
	self:superCall("ctor", p);
end

function Lua_CQiYuanPanel:buildShowItem(go)
	self.qyTaskList = Lua_DragList.new(self.content,1, Vector4(0, 0, 700, 390));
	self.qyTaskList:setListCell(Lua_CQiyuanItem, 130, 700, 1);
	self.qyTaskList:setLocation(204, -31, 0);

	self:addLuaEvent("GETONEINFO_UPDATA", self, self.updateQYTaskInfo);
end

function Lua_CQiYuanPanel:updateQYTaskInfo()
	local qiyuanData = DataCenter.qiyuanData;
	local len = qiyuanData.qyTaskArr:getSize();
	local val = 0;
	local redDotVal = 0;
	for i = 1, len do
		if qiyuanData.qyTaskArr[i].flag == 2 then
			val = val + 1;
		elseif qiyuanData.qyTaskArr[i].flag == 1 then
			redDotVal = 1;
		end
	end
	Lua_MsgUtil.callFunc("QIYUAN_VALUPDATA", {count = len, val = val,
		redDotVal = redDotVal, activeskill = qiyuanData.activeskill});

	self.qyTaskList:setLuaArrayData(qiyuanData.qyTaskArr, false)
end

function Lua_CQiYuanPanel:dispose()
	if self.qyTaskList ~= nil then
		self.qyTaskList:dispose();
		self.qyTaskList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_CQiyuanItem = class("Lua_CQiyuanItem", Lua_ListCell);
function Lua_CQiyuanItem:ctor(p)
	self:superCall("ctor", p, "Lua_QiYuanpanel_skin");
end

function Lua_CQiyuanItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemArr = Array();

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 236, 7, 0, 0);
	self.redDot.name = "redDot";
	self.redDot:setDepth(3);
end

function Lua_CQiyuanItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local len = #data.goodsid;
	local itemImg;
	local tvo;
	for i = 1, len do
		tvo = Lua_ToolVo.createToolVo(data.goodsid[i])
		tvo.star = 1;

		itemImg = self.itemArr[i];
		if itemImg == nil then
			itemImg = self.itemArr[i] or Lua_ToolImage.new(self.content);
			itemImg:setDepth(5);
			itemImg:setScale(0.9, 0.9, 0.9);
			itemImg:setLocation(-213 + (i - 1) * 90, -13, 0);

			self.itemArr:add(itemImg);
		end
		itemImg.data = tvo;
	end

	for i = len + 1, self.itemArr:getSize() do
		self.itemArr[i]:setEnable(false);
	end

	self.tipsLabel.text = data.name;

	if data.numreward == 1 then
		self.money:setAltas("icon_atlas_3", "money_209000001");
	elseif data.numreward == 2 then
		self.money:setAltas("icon_atlas_3", "money_209000002");
	elseif data.numreward == 3 then
		self.money:setAltas("icon_atlas_3", "money_209000003");
	end

	if data.flag ==  0 then -- 未达成
		self.btn.label = LanUtil.getValue(122311); 
		self.btn:removeClickFuntion(self, self.onbtnClick);
		self.btn:addClickFuntion(self, self.ongoClick);

		self.btn:setEnable(true);
		self.redDot:setEnable(false);
		self.getBg:setEnable(false);

		self.countLabel.text = string.format("[ebddcc]%s（[ff1d2a]%s[-]/%s[-]）",
			tostring(data.reward), tostring(0), tostring(1));
	elseif data.flag == 1 then -- 可领取
		self.btn.label = LanUtil.getValue(120813);
		self.btn:removeClickFuntion(self, self.ongoClick);
		self.btn:addClickFuntion(self, self.onbtnClick);

		self.btn:setEnable(true);
		self.redDot:setEnable(true);
		self.getBg:setEnable(false);

		self.countLabel.text = string.format("%s%s", tostring(data.reward), LanUtil.getValue(122318));
	else -- 已领取
		self.btn:setEnable(false);
		self.redDot:setEnable(false);
		self.getBg:setEnable(true);

		self.countLabel.text = string.format("%s%s", tostring(data.reward), LanUtil.getValue(122318));
	end
	self.money:setLocation(self.tipsLabel.mainContent.transform.localPosition.x + self.tipsLabel.width + 20, 39, 0);
	self.countLabel:setLocation(self.money.mainContent.transform.localPosition.x + 20, 39, 0)
end

function Lua_CQiyuanItem:onbtnClick()
	DataCenter.qiyuanData:getReward(self._data.chapter)
end

function Lua_CQiyuanItem:ongoClick()
	Lua_WindowUtil.openWin("Lua_ForgingWindow", WinParam.ACTION_OPEN, {openIdx = 3});
	Lua_WindowUtil.openWin("Lua_QiYuanWindow", WinParam.ACTION_CLOSE);
end

function Lua_CQiyuanItem:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end