-- 奇缘
checkRequire("Lua_QiYuanPanel");
checkRequire("Lua_MQiYuanPanel");
checkRequire("Lua_TQiYuanPanel");
checkRequire("Lua_CQiYuanPanel");
checkRequire("Lua_YQiYuanPanel");
checkRequire("Lua_QiyuanVo");
Lua_QiYuanWindow = class("Lua_QiYuanWindow", Lua_Window);
function Lua_QiYuanWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_QiYuanWindow";
	self.skinName = "Lua_QiYuanWindow_skin";
	self.showClose = false;
	self.count = -1;
end

function Lua_QiYuanWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.list = Array();
	self.list:add({name = LanUtil.getValue(122300), panel = Lua_QiYuanPanel, posY = 150});
	self.list:add({name = LanUtil.getValue(122301), panel = Lua_MQiYuanPanel, posY = 88});
	self.list:add({name = LanUtil.getValue(122302), panel = Lua_TQiYuanPanel, posY = 29});
	self.list:add({name = LanUtil.getValue(122303), panel = Lua_CQiYuanPanel, posY = -30});
	self.list:add({name = LanUtil.getValue(122303), panel = Lua_YQiYuanPanel, posY = -89});

	local baseInfo = Lua_QiyuanVo.new(0);
	self.chapterIdDic = {};
	local data;
	local config;
	local cell;
	self.qiyuanBtnList = Array();
	for i = 1, #baseInfo.piecevalue do
		self.chapterIdDic[baseInfo.piecevalue[i]] = i;
		data = Lua_QiyuanVo.new(baseInfo.piecevalue[i]);
		config = getConfig({"player_skill", data.skill})

		cell = Lua_QiYuanBtnItem.new(self.Panel);
		cell.desLab.text = data.name 
		cell.skill = config.skill_icon; 
		cell.skilltips = config.reMark;
		cell:setOpenInfo(baseInfo.piecevalue[i], i == #baseInfo.piecevalue, i);
		cell:setLocation(-478, self.list[i].posY, 0);
		self.qiyuanBtnList:add(cell); 
	end

	self.PanelObj = self.Panel:AddComponent(typeof(UIPanel));
	WindowMananger.getInstance():resetChildParent(self.Panel.transform);

	self:addLuaEvent("QIYUAN_VALUPDATA", self, self.qiyuanvalUpdata);
	self:addLuaEvent("QIYUAN_BTN_CLICK", self, self.updateQiYuanPanel);
	self:addLuaEvent("GETOPENINFO_UPDATA", self, self.updateQiYuanPanel);
	DataCenter.qiyuanData:getOpenInfo();
end

function Lua_QiYuanWindow:qiyuanvalUpdata(vo)
	local colorStr = vo.val < vo.count and "[FF1616]" or "[00E125]";
	local str = colorStr .. "（" .. vo.val .. "/" .. vo.count .. "）";
	self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(122304), str);

	if vo.activeskill == 1 then
		self.activate:setEnable(false);
		self.activateLab:setEnable(false);
	else
		self.activate:setEnable(true);
		self.activateLab:setEnable(true);
		self.activate:setAltas("common_atlas_1", "ui_common_bq_001");
		self.activateLab.text = LanUtil.getValue(122315);
	end

	for i = 1, self.qiyuanBtnList:getSize() do
		self.qiyuanBtnList[i].redDot:setEnable(DataCenter.qiyuanData.showhongdian == i);
	end
	self.qiyuanBtnList[5].redDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(10093));
end

function Lua_QiYuanWindow:updateQiYuanPanel(data)
	local qiyuanData = DataCenter.qiyuanData;
	local showOpenId = 0;
	local showIdx = 1;
	for i = 1, #qiyuanData.piece do
		showOpenId = qiyuanData.piece[i];
		showIdx = i;
	end

	local baseInfo = Lua_QiyuanVo.new(0);
	local selectOpenId;
	local isEndState;
	if data == nil then
		selectOpenId = qiyuanData.piece[showIdx];
		isEndState = qiyuanData.piece[showIdx] == baseInfo.piecevalue[#baseInfo.piecevalue];
	else
		showOpenId = data.openId;
		showIdx = data.index;

		selectOpenId = data.openId;
		isEndState = data.isEndState;
	end

	if not isEndState then
		if qiyuanData.openIdDic[selectOpenId] ~= 1 then
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(122308),
				tostring(self.qiyuanBtnList[showIdx - 1].desLab.text)));
			return;
		end
	end
	qiyuanData:getoneInfo(showOpenId);

	for i = 1, #baseInfo.piecevalue do
		self.qiyuanBtnList[i]:setData(showOpenId == baseInfo.piecevalue[i]);
	end
	self.qiyuanBtnList[5].redDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(10093));

	showIdx = self.chapterIdDic[showOpenId];
	self.skilltipsLab.text = self.qiyuanBtnList[showIdx].skilltips;
	self.skill:setAltas("skillIcon_atlas_1", self.qiyuanBtnList[showIdx].skill);

	if showIdx ~= self.curOpenId then
		if self.qiyuanpanel ~= nil  then	
			self.qiyuanpanel:dispose();
		end
		self.qiyuanpanel = self.list[showIdx].panel.new(self.content);
		self.curOpenId = showIdx;
	end
end

function Lua_QiYuanWindow:dispose()
	if self.list ~= nil then
		self.list:dispose();
		self.list:clear();
		self.list = nil;
	end
	if self.qiyuanBtnList ~= nil then
		self.qiyuanBtnList:dispose();
		self.qiyuanBtnList:clear();
		self.qiyuanBtnList = nil;
	end
	if self.qiyuanpanel ~= nil then
		self.qiyuanpanel:dispose();
		self.qiyuanpanel = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_QiYuanBtnItem = class("Lua_QiYuanBtnItem", Lua_DisplayObject);
function Lua_QiYuanBtnItem:ctor(p)
	self:superCall("ctor", p, "QiYuanBtnItem_skin");
end

function Lua_QiYuanBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.noSelectIcon:setEnable(false);
	self.redDot:setEnable(false);

	self.itemBg.alpha = 0.1;
	self.itemBg.clickScale = false;
	self.itemBg:addClickFuntion(self, self.onQiYuanBtnClick);
end

function Lua_QiYuanBtnItem:setOpenInfo(openId, isEndState, index)
	self._openId = openId;
	self._isEndState = isEndState;
	self._index = index;

	if isEndState then
		self.grayIcon:setEnable(false);
		self.noSelectIcon:setEnable(true);
		self.desLab.colorStr = Lua_ColorDefine.transColor("D4E9FF");
	else
		self.grayIcon:setEnable(true);
		self.noSelectIcon:setEnable(false);
		self.desLab.colorStr = Lua_ColorDefine.transColor("919DA6");
	end
end

-- 选中开启 E2FDFF，选中没开启 919DA6，没选中开启 D4E9FF，没选中没开启 919DA6
function Lua_QiYuanBtnItem:setData(isSelect)
	if self._isEndState then
		self.grayIcon:setEnable(false);
		self.noSelectIcon:setEnable(not isSelect);
		self.selectIcon:setEnable(isSelect);
		if isSelect then
			self.desLab.colorStr = Lua_ColorDefine.transColor("E2FDFF");
		else
			self.desLab.colorStr = Lua_ColorDefine.transColor("D4E9FF");
		end
	else
		local isOpen = DataCenter.qiyuanData.openIdDic[self._openId] == 1;
		self.grayIcon:setEnable(not isOpen);
		self.noSelectIcon:setEnable(not isSelect and isOpen);
		self.selectIcon:setEnable(isSelect and isOpen);
		if isSelect then
			if isOpen then
				self.desLab.colorStr = Lua_ColorDefine.transColor("E2FDFF");
			else
				self.desLab.colorStr = Lua_ColorDefine.transColor("919DA6");
			end
		else
			if isOpen then
				self.desLab.colorStr = Lua_ColorDefine.transColor("D4E9FF");
			else
				self.desLab.colorStr = Lua_ColorDefine.transColor("919DA6");
			end
		end
	end
end

function Lua_QiYuanBtnItem:onQiYuanBtnClick(go)
	Lua_MsgUtil.callFunc("QIYUAN_BTN_CLICK", {openId = self._openId, isEndState = self._isEndState, index = self._index});
end

function Lua_QiYuanBtnItem:dispose()
	self:superCall("dispose");
end